library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;	 	

entity RAM_module is   
	
	generic (
		image_width : positive := 128;
		image_height : positive := 128;
		template_width : positive := 32;
		template_height : positive := 32); 
	port (
		clk : in std_logic;
		we : in std_logic;
		addrA : in integer range 0 to image_width + template_width - 1;
		addrB : in integer range 0 to image_width + template_width - 1;
		di : in integer range 0 to 255;
		doA : out integer range 0 to 255;
		doB : out integer range 0 to 255);
end RAM_module;										  

architecture behavioral of RAM_module is				 

subtype small_integer is integer range 0 to 255;
type ram_type is array (0 to image_width + template_width - 1) of small_integer; 
signal RAM : ram_type;	 

begin
	
	process (clk)
	begin
		if rising_edge(clk) then
		doA <= RAM(addrA); 
		doB <= RAM(addrB);
			if we = '1' then
				RAM(addrA) <= di;
			end if;
		end if;
	end process; 

end behavioral;