close all
clear all

perf_results4 = [];

for ci = 8:34

close all
    
testImage = double(imread('face1.pgm'));
template = rot90(double(imread('nose1.pgm')),2);

size(testImage)
size(template)

testImage = 2*testImage/255 - 1;
template = 2*template/255 - 1;

testImage = padarray(testImage, [256-size(testImage,1) 256-size(testImage,2)], 0, 'post');
template = padarray(template, [256-size(template,1) 256-size(template,2)], 0, 'post');

gold = conv2(testImage,template);

figure
subplot(1,2,1)
imshow(template./max(max(template)))
subplot(1,2,2)
imshow(testImage./max(max(testImage)))

matlab_fft_template_rows = fft(template, [], 1);
matlab_fft_template_cols = fft(matlab_fft_template_rows, [], 2);

matlab_fft_image_rows = fft(testImage, [], 1);
matlab_fft_image_cols = fft(matlab_fft_image_rows, [], 2);

matlab_fft_multiplied = matlab_fft_template_cols .* matlab_fft_image_cols;

matlab_ifft_rows = ifft(matlab_fft_multiplied, [], 1);
matlab_ifft_cols = ifft(matlab_ifft_rows, [], 2);

res = real(matlab_ifft_cols);


figure
subplot(2,2,1)
plot(real(testImage(:)))
title('Scene image')
subplot(2,2,2)
plot(imag(testImage(:)),'g')

subplot(2,2,3)
plot(real(template(:)))
title('Template')
subplot(2,2,4)
plot(imag(template(:)),'g')

fpga_simulation_fft_image_rows = zeros(256);
for i = 1:size(testImage,2)
   fpga_simulation_fft_image_rows(i,:) = fpga_fft(testImage(i,:)',1,ci)';
end
fpga_simulation_fft_image_cols = zeros(256);
for i = 1:size(testImage,1)
    fpga_simulation_fft_image_cols(:,i) = fpga_fft(fpga_simulation_fft_image_rows(:,i),1,ci);
end

fpga_simulation_fft_template_rows = zeros(256);
for i = 1:size(template,2)
   fpga_simulation_fft_template_rows(i,:) = fpga_fft(template(i,:)',1,ci)';
end
fpga_simulation_fft_template_cols = zeros(256);
for i = 1:size(template,1)
    fpga_simulation_fft_template_cols(:,i) = fpga_fft(fpga_simulation_fft_template_rows(:,i),1,ci);
end

fpga_simulation_fft_product = fpga_simulation_fft_template_cols .* fpga_simulation_fft_image_cols;

figure
subplot(2,2,1)
plot(real(fpga_simulation_fft_image_rows(:)))
title ('fpga_simulation_fft_image_rows')
subplot(2,2,2)
plot(imag(fpga_simulation_fft_image_rows(:)),'r')
title ('fpga_simulation_fft_image_rows')
subplot(2,2,3)
plot(real(fpga_simulation_fft_template_rows(:)))
title ('fpga_simulation_fft_template_rows')
subplot(2,2,4)
plot(imag(fpga_simulation_fft_template_rows(:)),'r')
title ('fpga_simulation_fft_template_rows')


figure
subplot(2,2,1)
plot(real(fpga_simulation_fft_image_cols(:)))
title ('fpga_simulation_fft_image_cols')
subplot(2,2,2)
plot(imag(fpga_simulation_fft_image_cols(:)),'r')
title ('fpga_simulation_fft_image_cols')
subplot(2,2,3)
plot(real(fpga_simulation_fft_template_cols(:)))
title ('fpga_simulation_fft_template_cols')
subplot(2,2,4)
plot(imag(fpga_simulation_fft_template_cols(:)),'r')
title ('fpga_simulation_fft_template_cols')


figure
subplot(2,2,1)
plot(real(matlab_fft_multiplied(:)))
subplot(2,2,2)
plot(real(fpga_simulation_fft_product(:)),'r')
title('fpga_simulation_fft_product')
subplot(2,2,3)
plot(imag(matlab_fft_multiplied(:)))
subplot(2,2,4)
plot(imag(fpga_simulation_fft_product(:)),'r')


fpga_simulation_ifft_rows = zeros(256);
for i = 1:size(testImage,2)
   fpga_simulation_ifft_rows(i,:) = fpga_fft(64*fpga_simulation_fft_product(i,:)',0,ci)';
end
fpga_simulation_ifft_cols = zeros(256);
for i = 1:size(testImage,1)
    fpga_simulation_ifft_cols(:,i) = fpga_fft(fpga_simulation_ifft_rows(:,i),0,ci);
end

figure
subplot(2,2,1)                                                                    
plot(real(matlab_ifft_rows(:)))
subplot(2,2,2)
plot(real(fpga_simulation_ifft_rows(:)),'r')

subplot(2,2,3)
plot(imag(matlab_ifft_rows(:)))
subplot(2,2,4)
plot(imag(fpga_simulation_ifft_rows(:)),'r')

figure
subplot(2,2,1)
plot(real(matlab_ifft_cols(:)))
subplot(2,2,2)
plot(real(fpga_simulation_ifft_cols(:)),'r')

subplot(2,2,3)
plot(imag(matlab_ifft_cols(:)))
subplot(2,2,4)
plot(imag(fpga_simulation_ifft_cols(:)),'r')


fpga_simulation_ifft_cols = real(fpga_simulation_ifft_cols);
figure
imshow(fpga_simulation_ifft_cols)

res = real(res);

gold = real(gold);
% 
figure 
subplot(1,3,1)
plot(gold(:))
subplot(1,3,2)
plot(res(:), 'r')
subplot(1,3,3)
plot(fpga_simulation_ifft_cols(:),'g')

fpga_simulation_ifft_cols = mynormalize(fpga_simulation_ifft_cols);
res = mynormalize(res);

figure 

plot(res(:), 'r')
hold on
plot(fpga_simulation_ifft_cols(:),'g')

sum_abs = abs(fpga_simulation_ifft_cols - res);
perf_results4 = [perf_results4 sum(sum_abs(:))];

end

save perf_results4
figure
stem(perf_results4)